// LibDump.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "LibDump.h"
#include "MainFrm.h"
#include "LibDumpDoc.h"
#include "LibDumpView.h"
#include "StaticLink.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLibDumpApp

BEGIN_MESSAGE_MAP(CLibDumpApp, CWinApp)
	//{{AFX_MSG_MAP(CLibDumpApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_FILE_PRINT_SETUP, OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLibDumpApp construction

CLibDumpApp::CLibDumpApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CLibDumpApp object

CLibDumpApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CLibDumpApp initialization

BOOL CLibDumpApp::Win3231()
{
	DWORD dwVersion = GetVersion();
	DWORD dwWindowsMajorVersion = (DWORD)(LOBYTE(LOWORD(dwVersion)));
	BOOL bWin3231 = dwWindowsMajorVersion < 4;
	if(bWin3231)
	{
		CString sMsg;
		sMsg.LoadString(IDS_VERSION_CHECK);
		AfxMessageBox(sMsg, MB_ICONINFORMATION);
	}

	return bWin3231;
}

BOOL CLibDumpApp::InitInstance()
{
	CWaitCursor wait;

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif
	
	if(Win3231())
		return FALSE;

	// Initialize OLE libraries
	if(!AfxOleInit())
	{
		AfxMessageBox(IDP_OLE_INIT_FAILED);
		return FALSE;
	}

	AfxEnableControlContainer();

	BOOL bFoundAppUninstall = (
		(!CString(m_lpCmdLine).CompareNoCase(_T("-Unregister"))) ||
		(!CString(m_lpCmdLine).CompareNoCase(_T("/Unregister")))
		);
	if(m_lpCmdLine[0] != '\0' && !bFoundAppUninstall)
	{
		// Supports only app uninstall
		CString str;
		str.LoadString(IDS_COMMAND_LINE_USAGE);
		AfxMessageBox(str, MB_ICONINFORMATION);
		return FALSE;
	}

	// Change the registry key under which our settings are stored.
	// You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("George Poulose"));

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	// serve as the connection between documents, frame windows and views.
	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CLibDumpDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CLibDumpView));
	AddDocTemplate(pDocTemplate);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if(!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The one and only window has been initialized, so show and update it.
	((CMainFrame*)m_pMainWnd)->InitialShowWindow(SW_SHOWNORMAL);

	return TRUE;
}

CString CLibDumpApp::GetLibDumpTempPath()
{
	if(m_strLibDumpTempPath.IsEmpty())
	{
		TCHAR lpszTempPath[_MAX_PATH*2];
		DWORD dwSize = ::GetTempPath(_MAX_PATH*2, lpszTempPath);
		ASSERT(dwSize != 0);
		m_strLibDumpTempPath = lpszTempPath;
	}

	return m_strLibDumpTempPath;			
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CStatic	m_staticHomeText;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	COLORREF m_colorUnvisited;
	COLORREF m_colorVisited;
	BOOL m_bVisited;
	CStaticLink m_staticHomeLink;
	CFont m_font;
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT

	m_colorUnvisited = RGB(0, 0, 255);	 // blue
	m_colorVisited   = RGB(128, 0, 128); // purple
	m_bVisited       = FALSE;
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_HOME_TEXT, m_staticHomeText);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_WM_CTLCOLOR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CLibDumpApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CLibDumpApp commands

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CRect rect;
	m_staticHomeText.GetWindowRect(&rect);
	ScreenToClient(&rect);
	if(!m_staticHomeLink.Create(_T(""),	WS_CHILD | WS_VISIBLE, rect, this, 0))
		TRACE(_T("Failed to create URL link.\n"));
	else
		m_staticHomeLink.m_strLink = _T("http://gpoulose.home.att.net/");

	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

HBRUSH CAboutDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	
	if(pWnd == &m_staticHomeText)
	{
		if(!(HFONT)m_font)
		{
			LOGFONT lf;
			GetFont()->GetObject(sizeof(lf), &lf);
			lf.lfUnderline = TRUE;
			if(m_font.CreateFontIndirect(&lf))
				pWnd->SetFont(&m_font);
		}
		
		pDC->SelectObject(&m_font);
		pDC->SetTextColor(
			m_staticHomeLink.m_bVisited ? m_colorVisited : m_colorUnvisited
			);
		
		pDC->SetBkMode(TRANSPARENT);
				
		hbr = (HBRUSH)::GetStockObject(HOLLOW_BRUSH);
	}

	return hbr;	
}